/* REXX script to check if login is ok before prompting for username.

   RETURN 0 = Login is ok.
   RETURN '421 text' = Login is not ok.
*/
parse arg socket args

if ( BITAND( IPSVAR( socket, '%(debugflag)' ), 8 ) = 8 ) then debug = 1
else debug = 0;

if debug then call IPSLOG socket, 'OnConnect: Start';

hostid = ipsVar( socket, '%(remoteip)' )
limith = ipsCfg( socket, ipsVar( socket, '%(configfile)' ), ipsVar( socket, '%(configsection)' ), 'LimitSameHost' )
if ( limith <= 0 ) then limith = 32

firstsocket = socket
do while ( ipsVar( firstsocket, '%(sock.prev)' ) > 0 )
  firstsocket = ipsVar( firstsocket, '%(sock.prev)' )
end

currentsocket = firstsocket
counthosts = 0
do while ( currentsocket > 0 )
  if ( ipsVar( currentsocket, '%(remoteip)' ) = hostid ) then do
    if ( currentsocket <> socket ) then do
      counthosts = counthosts + 1
    end
  end
  currentsocket = ipsVar( currentsocket, '%(sock.next)' )
end

if ( counthosts >= limith ) then do
  return '421 No more connections from accepted from 'hostid', try again later.'
end

return 0
