/*******************************************************************************
  InetPowerServer/2 - Rexx startup script

  This script is the correct way to start IPS to with
*******************************************************************************/
parse arg par1 trash;

call RxFuncAdd 'SysLoadFuncs', 'RexxUtil', 'SysLoadFuncs';
call SysLoadFuncs;

if ( par1 = 'DoStartup' ) then do
  do until ( rc = 0 )
    if ( stream( 'bin\history.cmd', 'c', 'query exist' ) <> '' )  then do
      parse value time( 'L' ) with hour':'min':'sec'.'hsec'0000';
      filename = date( 'S' )'-'hour||min||sec||hsec'.zip';
      '@'value( 'COMSPEC',,'OS2ENVIRONMENT' )' /C bin\history.cmd 'filename'>log\history.log';
    end;

    if ( stream( 'bin\ips2upd.exe', 'c', 'query exist' ) <> '' )  then do
      call LogIt 'New IPS executable found, testing file';
      '@bin\ips2upd -chkexe';
      if ( rc = 5 ) then do
	call LogIt 'New file was ok, upgrading';
        '@'value( 'COMSPEC',,'OS2ENVIRONMENT' )' /C bin\update.cmd >log\update.log';
      end
      else
        call LogIt 'New file was corrupt, not upgrading' ;
    end;

    '@bin\ips2';
    err = rc;
    if ( err > 0 ) then do
      call LogIt 'Error #'rc', restarting IPS';
    end;
  end;

  return 0;
end;

'@START "InetPowerServer/2" /C /MIN startips.cmd DoStartup';
say;
say 'Starting InetPowerServer/2 minimized ...';
return 0;

LogIt:
parse arg logtxt;

log = 'log\ips.log';
rc = stream( log, 'c', 'open' );
rc = stream( log, 'c', 'seek <0' );
dt = ' 'substr( time( 'L' ), 1, 8 )','substr( time( 'L' ), 10, 2 );
call lineout log, dt' 'logtxt;
rc = stream( log, 'c', 'close' );

return;
